diff --git a/src/main/java/net/minecraft/client/render/model/ModelQuadruped.java b/src/main/java/net/minecraft/client/render/model/QuadrupedModel.java
similarity index 62%
rename from src/main/java/net/minecraft/client/render/model/ModelQuadruped.java
rename to src/main/java/net/minecraft/client/render/model/QuadrupedModel.java
index 245959bc2..d089d3f13 100644
--- a/src/main/java/net/minecraft/client/render/model/ModelQuadruped.java
+++ b/src/main/java/net/minecraft/client/render/model/QuadrupedModel.java
@@ -2,14 +2,14 @@ package net.minecraft.client.render.model;
 
 
 // Referenced classes of package net.minecraft.src:
-//            ModelBase, ModelRenderer, MathHelper
+//            BaseModel, ModelRenderer, MathHelper
 
 import net.minecraft.core.util.helper.MathHelper;
 
-public class ModelQuadruped extends ModelBase
+public class QuadrupedModel extends BaseModel
 {
 
-    public ModelQuadruped(int i, float f)
+    public QuadrupedModel(int i, float f)
     {
         head = new Cube(0, 0);
         head.addBox(-4F, -4F, -8F, 8, 8, 8, f);
@@ -34,7 +34,7 @@ public class ModelQuadruped extends ModelBase
     @Override
     public void render(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
     {
-        setRotationAngles(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+        setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
         head.render(scale);
         body.render(scale);
         leg1.render(scale);
@@ -44,15 +44,15 @@ public class ModelQuadruped extends ModelBase
     }
 
     @Override
-    public void setRotationAngles(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
     {
-        head.rotateAngleX = headPitch / 57.29578F;
-        head.rotateAngleY = headYaw / 57.29578F;
-        body.rotateAngleX = 1.570796F;
-        leg1.rotateAngleX = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
-        leg2.rotateAngleX = MathHelper.cos(limbSwing * 0.6662F + 3.141593F) * 1.4F * limbYaw;
-        leg3.rotateAngleX = MathHelper.cos(limbSwing * 0.6662F + 3.141593F) * 1.4F * limbYaw;
-        leg4.rotateAngleX = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
+        head.xRot = headPitch / 57.29578F;
+        head.yRot = headYaw / 57.29578F;
+        body.xRot = MathHelper.PI / 2F;
+        leg1.xRot = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
+        leg2.xRot = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 1.4F * limbYaw;
+        leg3.xRot = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 1.4F * limbYaw;
+        leg4.xRot = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
     }
 
     public Cube head;
diff --git a/src/main/java/net/minecraft/client/render/model/ModelScorpion.java b/src/main/java/net/minecraft/client/render/model/ScorpionModel.java
similarity index 87%
rename from src/main/java/net/minecraft/client/render/model/ModelScorpion.java
rename to src/main/java/net/minecraft/client/render/model/ScorpionModel.java
index 20c14579e..285c2405d 100644
--- a/src/main/java/net/minecraft/client/render/model/ModelScorpion.java
+++ b/src/main/java/net/minecraft/client/render/model/ScorpionModel.java
@@ -3,7 +3,7 @@ package net.minecraft.client.render.model;
 import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.opengl.GL11;
 
-public class ModelScorpion extends ModelBase
+public class ScorpionModel extends BaseModel
 {
     private final Cube body;
     private final Cube clawLeft;
@@ -19,7 +19,7 @@ public class ModelScorpion extends ModelBase
     private final Cube tail2;
 
 
-    public ModelScorpion()
+    public ScorpionModel()
     {
         body = new Cube(0, 0);
         body.addBox(-2.5F, -4.0F, -5.0F, 5, 3, 10);
@@ -84,7 +84,7 @@ public class ModelScorpion extends ModelBase
     @Override
     public void render(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
     {
-        setRotationAngles(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+        setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
 
         GL11.glPushMatrix();
         GL11.glTranslatef(0, 1.4F, 0);
@@ -105,7 +105,7 @@ public class ModelScorpion extends ModelBase
     }
 
     @Override
-    public void setRotationAngles(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
     {
         legLFront.setRotationAngle(0.0F, -2.618F, 0.3927F);
         legLMid.setRotationAngle(0.0F, 3.1416F, 0.3927F);
@@ -115,16 +115,16 @@ public class ModelScorpion extends ModelBase
         legRBack.setRotationAngle(0.0F, 0.5236F, -0.3927F);
 
         float pair1Y = -(MathHelper.cos(limbSwing * 0.6662F * 2.0F + 0.0F) * 0.4F) * limbYaw;
-        float pair2Y = -(MathHelper.cos(limbSwing * 0.6662F * 2.0F + 3.141593F) * 0.4F) * limbYaw;
-        float pair3Y = -(MathHelper.cos(limbSwing * 0.6662F * 2.0F + 1.570796F) * 0.4F) * limbYaw;
+        float pair2Y = -(MathHelper.cos(limbSwing * 0.6662F * 2.0F + MathHelper.PI) * 0.4F) * limbYaw;
+        float pair3Y = -(MathHelper.cos(limbSwing * 0.6662F * 2.0F + MathHelper.PI / 2F) * 0.4F) * limbYaw;
 
-        legLFront.rotateAngleY += pair1Y;
-        legLBack.rotateAngleY -= pair1Y;
+        legLFront.yRot += pair1Y;
+        legLBack.yRot -= pair1Y;
 
-        legRFront.rotateAngleY -= pair2Y;
-        legRBack.rotateAngleY += pair2Y;
+        legRFront.yRot -= pair2Y;
+        legRBack.yRot += pair2Y;
 
-        legLMid.rotateAngleY += pair3Y;
-        legRMid.rotateAngleY -= pair3Y;
+        legLMid.yRot += pair3Y;
+        legRMid.yRot -= pair3Y;
     }
 }
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/client/render/model/ModelSheep.java b/src/main/java/net/minecraft/client/render/model/SheepModel.java
similarity index 56%
rename from src/main/java/net/minecraft/client/render/model/ModelSheep.java
rename to src/main/java/net/minecraft/client/render/model/SheepModel.java
index 257d10bb9..3d8acb520 100644
--- a/src/main/java/net/minecraft/client/render/model/ModelSheep.java
+++ b/src/main/java/net/minecraft/client/render/model/SheepModel.java
@@ -2,16 +2,16 @@ package net.minecraft.client.render.model;
 
 
 // Referenced classes of package net.minecraft.src:
-//            ModelQuadruped, ModelRenderer
+//            QuadrupedModel, ModelRenderer
 
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.animal.EntitySheep;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.animal.SheepMob;
 import net.minecraft.core.util.helper.MathHelper;
 
-public class ModelSheep extends ModelQuadruped
+public class SheepModel extends QuadrupedModel
 {
 
-    public ModelSheep()
+    public SheepModel()
     {
         super(12, 0.0F);
         head = new Cube(0, 0);
@@ -23,9 +23,9 @@ public class ModelSheep extends ModelQuadruped
     }
 
     @Override
-    public void setRotationAngles(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
     {
-        super.setRotationAngles(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+        super.setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
         float desiredRotateAngleX = headPitch / 57.29578F;
         float desiredRotateAngleY = headYaw / 57.29578F;
         // handles head rotation
@@ -35,36 +35,36 @@ public class ModelSheep extends ModelQuadruped
             if (headBobTime < 5)
             {
                 float partPercentage = headBobTime / 5;
-                head.rotateAngleX = (desiredRotateAngleX * (1 - partPercentage)) + (1.0472f * partPercentage);
-                head.rotateAngleY = (desiredRotateAngleY * (1 - partPercentage));
+                head.xRot = (desiredRotateAngleX * (1 - partPercentage)) + (1.0472f * partPercentage);
+                head.yRot = (desiredRotateAngleY * (1 - partPercentage));
             }
             //hold head in tilted position
             else if (headBobTime < 35)
             {
-                head.rotateAngleX = 1.0472f;
-                head.rotateAngleY = 0;
+                head.xRot = 1.0472f;
+                head.yRot = 0;
             }
             // bring head up to normal rotation again
             else if (headBobTime < 40)
             {
                 float partPercentage = (headBobTime - 35) / 5;
-                head.rotateAngleX = (desiredRotateAngleX * partPercentage) + (1.0472f * (1 - partPercentage));
-                head.rotateAngleY = desiredRotateAngleY * partPercentage;
+                head.xRot = (desiredRotateAngleX * partPercentage) + (1.0472f * (1 - partPercentage));
+                head.yRot = desiredRotateAngleY * partPercentage;
             }
         }
         else
         {
             // normal head rotations
-            head.rotateAngleX = desiredRotateAngleX;
-            head.rotateAngleY = desiredRotateAngleY;
+            head.xRot = desiredRotateAngleX;
+            head.yRot = desiredRotateAngleY;
         }
     }
 
     @Override
-    public void setLivingAnimations(EntityLiving entityliving, float limbSwing, float limbYaw, float partialTick)
+    public void setLivingAnimations(Mob mob, float limbSwing, float limbYaw, float partialTick)
     {
-        EntitySheep entitySheep = (EntitySheep) entityliving;
-        head.rotationPointY = 6F;
+        SheepMob entitySheep = (SheepMob) mob;
+        head.y = 6F;
         isEatingAnimPlaying = false;
         if(entitySheep.getIsSheepEating())
         {
@@ -74,17 +74,17 @@ public class ModelSheep extends ModelQuadruped
             // Move head down
             if (headBobTime < 5)
             {
-                head.rotationPointY = 6 + (10 / 5f) * (headBobTime + 1);
+                head.y = 6 + (10 / 5f) * (headBobTime + 1);
             }
             // Hold head down and bob
             else if (headBobTime < 35)
             {
-                head.rotationPointY = 16 + MathHelper.sin((headBobTime * 0.05f) * 30.5f) / 3f;
+                head.y = 16 + MathHelper.sin((headBobTime * 0.05f) * 30.5f) / 3f;
             }
             // Bring head back up
             else if (headBobTime < 40)
             {
-                head.rotationPointY = 16f - ((10 / 5f) * (headBobTime - 34));
+                head.y = 16f - ((10 / 5f) * (headBobTime - 34));
             }
         }
         else
diff --git a/src/main/java/net/minecraft/client/render/model/SheepOverlayModel.java b/src/main/java/net/minecraft/client/render/model/SheepOverlayModel.java
new file mode 100644
index 000000000..5c3034c99
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/model/SheepOverlayModel.java
@@ -0,0 +1,44 @@
+package net.minecraft.client.render.model;
+
+
+// Referenced classes of package net.minecraft.src:
+//            QuadrupedModel, ModelRenderer
+
+import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.core.Global;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.animal.SheepMob;
+import org.lwjgl.opengl.GL11;
+
+public class SheepOverlayModel extends SheepModel
+{
+    Mob sheep;
+
+    public SheepOverlayModel()
+    {
+        super();
+    }
+
+    @Override
+    public void setLivingAnimations(Mob mob, float limbSwing, float limbYaw, float partialTick)
+    {
+        super.setLivingAnimations(mob, limbSwing, limbYaw, partialTick);
+        this.sheep = mob;
+        float brightness = sheep.getBrightness(limbSwing);
+        if (Global.accessor.isFullbrightEnabled() || LightmapHelper.isLightmapEnabled()) brightness = 1.0f;
+        int j = ((SheepMob)sheep).getFleeceColor().blockMeta;
+        GL11.glColor3f(brightness * SheepMob.FLEECE_COLOR_TABLE[j][0], brightness * SheepMob.FLEECE_COLOR_TABLE[j][1], brightness * SheepMob.FLEECE_COLOR_TABLE[j][2]);
+
+    }
+
+    @Override
+    public void onUnload(){
+        sheep = null;
+    }
+
+    @Override
+    public void render(float limbSwing, float limbYaw, float ticksExisted, float headYaw, float headPitch, float scale)
+    {
+        super.render(limbSwing, limbYaw, ticksExisted, headYaw, headPitch, scale);
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/model/ModelSheepWool.java b/src/main/java/net/minecraft/client/render/model/SheepWoolModel.java
similarity index 88%
rename from src/main/java/net/minecraft/client/render/model/ModelSheepWool.java
rename to src/main/java/net/minecraft/client/render/model/SheepWoolModel.java
index f71921810..de73c81e2 100644
--- a/src/main/java/net/minecraft/client/render/model/ModelSheepWool.java
+++ b/src/main/java/net/minecraft/client/render/model/SheepWoolModel.java
@@ -2,12 +2,12 @@ package net.minecraft.client.render.model;
 
 
 // Referenced classes of package net.minecraft.src:
-//            ModelQuadruped, ModelRenderer
+//            QuadrupedModel, ModelRenderer
 
-public class ModelSheepWool extends ModelSheep
+public class SheepWoolModel extends SheepModel
 {
 
-    public ModelSheepWool()
+    public SheepWoolModel()
     {
         head = new Cube(0, 0);
         head.addBox(-3F, -4F, -4F, 6, 6, 6, 0.6F);
diff --git a/src/main/java/net/minecraft/client/render/model/ModelSign.java b/src/main/java/net/minecraft/client/render/model/SignModel.java
similarity index 91%
rename from src/main/java/net/minecraft/client/render/model/ModelSign.java
rename to src/main/java/net/minecraft/client/render/model/SignModel.java
index cdfb93dfa..bacc3e4d8 100644
--- a/src/main/java/net/minecraft/client/render/model/ModelSign.java
+++ b/src/main/java/net/minecraft/client/render/model/SignModel.java
@@ -4,10 +4,10 @@ package net.minecraft.client.render.model;
 // Referenced classes of package net.minecraft.src:
 //            ModelRenderer
 
-public class ModelSign
+public class SignModel
 {
 
-    public ModelSign()
+    public SignModel()
     {
         signBoard = new Cube(0, 0);
         signBoard.addBox(-12F, -14F, -1F, 24, 12, 2, 0.0F);
diff --git a/src/main/java/net/minecraft/client/render/model/SkeletonModel.java b/src/main/java/net/minecraft/client/render/model/SkeletonModel.java
new file mode 100644
index 000000000..c32dd8f07
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/model/SkeletonModel.java
@@ -0,0 +1,28 @@
+package net.minecraft.client.render.model;
+
+
+// Referenced classes of package net.minecraft.src:
+//            ZombieModel, ModelRenderer
+
+public class SkeletonModel extends ZombieModel
+{
+
+    public SkeletonModel()
+    {
+        float f = 0.0F;
+        arm0 = new Cube(40, 16);
+        arm0.addBox(-1F, -2F, -1F, 2, 12, 2, f);
+        arm0.setRotationPoint(-5F, 2.0F, 0.0F);
+        arm1 = new Cube(40, 16);
+        arm1.mirror = true;
+        arm1.addBox(-1F, -2F, -1F, 2, 12, 2, f);
+        arm1.setRotationPoint(5F, 2.0F, 0.0F);
+        leg0 = new Cube(0, 16);
+        leg0.addBox(-1F, 0.0F, -1F, 2, 12, 2, f);
+        leg0.setRotationPoint(-2F, 12F, 0.0F);
+        leg1 = new Cube(0, 16);
+        leg1.mirror = true;
+        leg1.addBox(-1F, 0.0F, -1F, 2, 12, 2, f);
+        leg1.setRotationPoint(2.0F, 12F, 0.0F);
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/model/ModelSlime.java b/src/main/java/net/minecraft/client/render/model/SlimeModel.java
similarity index 77%
rename from src/main/java/net/minecraft/client/render/model/ModelSlime.java
rename to src/main/java/net/minecraft/client/render/model/SlimeModel.java
index 69fa83c0d..f025a7e14 100644
--- a/src/main/java/net/minecraft/client/render/model/ModelSlime.java
+++ b/src/main/java/net/minecraft/client/render/model/SlimeModel.java
@@ -2,12 +2,12 @@ package net.minecraft.client.render.model;
 
 
 // Referenced classes of package net.minecraft.src:
-//            ModelBase, ModelRenderer
+//            BaseModel, ModelRenderer
 
-public class ModelSlime extends ModelBase
+public class SlimeModel extends BaseModel
 {
 
-    public ModelSlime(int i)
+    public SlimeModel(int i)
     {
         slimeBodies = new Cube(0, i);
         slimeBodies.addBox(-4F, 16F, -4F, 8, 8, 8);
@@ -25,14 +25,14 @@ public class ModelSlime extends ModelBase
     }
 
     @Override
-    public void setRotationAngles(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
     {
     }
 
     @Override
     public void render(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
     {
-        setRotationAngles(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+        setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
         slimeBodies.render(scale);
         if(slimeRightEye != null)
         {
diff --git a/src/main/java/net/minecraft/client/render/model/ModelSpider.java b/src/main/java/net/minecraft/client/render/model/SpiderModel.java
similarity index 50%
rename from src/main/java/net/minecraft/client/render/model/ModelSpider.java
rename to src/main/java/net/minecraft/client/render/model/SpiderModel.java
index c685d7ca3..833a973bc 100644
--- a/src/main/java/net/minecraft/client/render/model/ModelSpider.java
+++ b/src/main/java/net/minecraft/client/render/model/SpiderModel.java
@@ -2,55 +2,67 @@ package net.minecraft.client.render.model;
 
 
 // Referenced classes of package net.minecraft.src:
-//            ModelBase, ModelRenderer, MathHelper
+//            BaseModel, ModelRenderer, MathHelper
 
 import net.minecraft.core.util.helper.MathHelper;
 
-public class ModelSpider extends ModelBase
+public class SpiderModel extends BaseModel
 {
+    public Cube spiderHead;
+    public Cube spiderNeck;
+    public Cube spiderBody;
+    public Cube spiderLeg1;
+    public Cube spiderLeg2;
+    public Cube spiderLeg3;
+    public Cube spiderLeg4;
+    public Cube spiderLeg5;
+    public Cube spiderLeg6;
+    public Cube spiderLeg7;
+    public Cube spiderLeg8;
+
 
-    public ModelSpider(float expandAmount)
+    public SpiderModel(float expandAmount)
     {
-        int i = 15;
+        int yOff = 15;
         spiderHead = new Cube(32, 4);
         spiderHead.addBox(-4F, -4F, -8F, 8, 8, 8, expandAmount);
-        spiderHead.setRotationPoint(0.0F, 0 + i, -3F);
+        spiderHead.setRotationPoint(0.0F, yOff, -3F);
         spiderNeck = new Cube(0, 0);
         spiderNeck.addBox(-3F, -3F, -3F, 6, 6, 6, expandAmount);
-        spiderNeck.setRotationPoint(0.0F, i, 0.0F);
+        spiderNeck.setRotationPoint(0.0F, yOff, 0.0F);
         spiderBody = new Cube(0, 12);
         spiderBody.addBox(-5F, -4F, -6F, 10, 8, 12, expandAmount);
-        spiderBody.setRotationPoint(0.0F, 0 + i, 9F);
+        spiderBody.setRotationPoint(0.0F, yOff, 9F);
         spiderLeg1 = new Cube(18, 0);
         spiderLeg1.addBox(-15F, -1F, -1F, 16, 2, 2, expandAmount);
-        spiderLeg1.setRotationPoint(-4F, 0 + i, 2.0F);
+        spiderLeg1.setRotationPoint(-4F, yOff, 2.0F);
         spiderLeg2 = new Cube(18, 0);
         spiderLeg2.addBox(-1F, -1F, -1F, 16, 2, 2, expandAmount);
-        spiderLeg2.setRotationPoint(4F, 0 + i, 2.0F);
+        spiderLeg2.setRotationPoint(4F, yOff, 2.0F);
         spiderLeg3 = new Cube(18, 0);
         spiderLeg3.addBox(-15F, -1F, -1F, 16, 2, 2, expandAmount);
-        spiderLeg3.setRotationPoint(-4F, 0 + i, 1.0F);
+        spiderLeg3.setRotationPoint(-4F, yOff, 1.0F);
         spiderLeg4 = new Cube(18, 0);
         spiderLeg4.addBox(-1F, -1F, -1F, 16, 2, 2, expandAmount);
-        spiderLeg4.setRotationPoint(4F, 0 + i, 1.0F);
+        spiderLeg4.setRotationPoint(4F, yOff, 1.0F);
         spiderLeg5 = new Cube(18, 0);
         spiderLeg5.addBox(-15F, -1F, -1F, 16, 2, 2, expandAmount);
-        spiderLeg5.setRotationPoint(-4F, 0 + i, 0.0F);
+        spiderLeg5.setRotationPoint(-4F, yOff, 0.0F);
         spiderLeg6 = new Cube(18, 0);
         spiderLeg6.addBox(-1F, -1F, -1F, 16, 2, 2, expandAmount);
-        spiderLeg6.setRotationPoint(4F, 0 + i, 0.0F);
+        spiderLeg6.setRotationPoint(4F, yOff, 0.0F);
         spiderLeg7 = new Cube(18, 0);
         spiderLeg7.addBox(-15F, -1F, -1F, 16, 2, 2, expandAmount);
-        spiderLeg7.setRotationPoint(-4F, 0 + i, -1F);
+        spiderLeg7.setRotationPoint(-4F, yOff, -1F);
         spiderLeg8 = new Cube(18, 0);
         spiderLeg8.addBox(-1F, -1F, -1F, 16, 2, 2, expandAmount);
-        spiderLeg8.setRotationPoint(4F, 0 + i, -1F);
+        spiderLeg8.setRotationPoint(4F, yOff, -1F);
     }
 
     @Override
     public void render(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
     {
-        setRotationAngles(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+        setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
         spiderHead.render(scale);
         spiderNeck.render(scale);
         spiderBody.render(scale);
@@ -65,64 +77,52 @@ public class ModelSpider extends ModelBase
     }
 
     @Override
-    public void setRotationAngles(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
     {
-        spiderHead.rotateAngleY = headYaw / 57.29578F;
-        spiderHead.rotateAngleX = headPitch / 57.29578F;
+        spiderHead.yRot = headYaw / 57.29578F;
+        spiderHead.xRot = headPitch / 57.29578F;
         float f6 = 0.7853982F;
-        spiderLeg1.rotateAngleZ = -f6;
-        spiderLeg2.rotateAngleZ = f6;
-        spiderLeg3.rotateAngleZ = -f6 * 0.74F;
-        spiderLeg4.rotateAngleZ = f6 * 0.74F;
-        spiderLeg5.rotateAngleZ = -f6 * 0.74F;
-        spiderLeg6.rotateAngleZ = f6 * 0.74F;
-        spiderLeg7.rotateAngleZ = -f6;
-        spiderLeg8.rotateAngleZ = f6;
+        spiderLeg1.zRot = -f6;
+        spiderLeg2.zRot = f6;
+        spiderLeg3.zRot = -f6 * 0.74F;
+        spiderLeg4.zRot = f6 * 0.74F;
+        spiderLeg5.zRot = -f6 * 0.74F;
+        spiderLeg6.zRot = f6 * 0.74F;
+        spiderLeg7.zRot = -f6;
+        spiderLeg8.zRot = f6;
         float f7 = -0F;
         float f8 = 0.3926991F;
-        spiderLeg1.rotateAngleY = f8 * 2.0F + f7;
-        spiderLeg2.rotateAngleY = -f8 * 2.0F - f7;
-        spiderLeg3.rotateAngleY = f8 * 1.0F + f7;
-        spiderLeg4.rotateAngleY = -f8 * 1.0F - f7;
-        spiderLeg5.rotateAngleY = -f8 * 1.0F + f7;
-        spiderLeg6.rotateAngleY = f8 * 1.0F - f7;
-        spiderLeg7.rotateAngleY = -f8 * 2.0F + f7;
-        spiderLeg8.rotateAngleY = f8 * 2.0F - f7;
+        spiderLeg1.yRot = f8 * 2.0F + f7;
+        spiderLeg2.yRot = -f8 * 2.0F - f7;
+        spiderLeg3.yRot = f8 + f7;
+        spiderLeg4.yRot = -f8 - f7;
+        spiderLeg5.yRot = -f8 + f7;
+        spiderLeg6.yRot = f8 - f7;
+        spiderLeg7.yRot = -f8 * 2.0F + f7;
+        spiderLeg8.yRot = f8 * 2.0F - f7;
         float pair1Y = -(MathHelper.cos(limbSwing * 0.6662F * 2.0F + 0.0F) * 0.4F) * limbYaw;
-        float pair2Y = -(MathHelper.cos(limbSwing * 0.6662F * 2.0F + 3.141593F) * 0.4F) * limbYaw;
-        float pair3Y = -(MathHelper.cos(limbSwing * 0.6662F * 2.0F + 1.570796F) * 0.4F) * limbYaw;
-        float pair4Y = -(MathHelper.cos(limbSwing * 0.6662F * 2.0F + 4.712389F) * 0.4F) * limbYaw;
+        float pair2Y = -(MathHelper.cos(limbSwing * 0.6662F * 2.0F + MathHelper.PI) * 0.4F) * limbYaw;
+        float pair3Y = -(MathHelper.cos(limbSwing * 0.6662F * 2.0F + MathHelper.PI / 2F) * 0.4F) * limbYaw;
+        float pair4Y = -(MathHelper.cos(limbSwing * 0.6662F * 2.0F + MathHelper.PI * 1.5F) * 0.4F) * limbYaw;
         float pair1Z = Math.abs(MathHelper.sin(limbSwing * 0.6662F + 0.0F) * 0.4F) * limbYaw;
-        float pair2Z = Math.abs(MathHelper.sin(limbSwing * 0.6662F + 3.141593F) * 0.4F) * limbYaw;
-        float pair3Z = Math.abs(MathHelper.sin(limbSwing * 0.6662F + 1.570796F) * 0.4F) * limbYaw;
-        float pair4Z = Math.abs(MathHelper.sin(limbSwing * 0.6662F + 4.712389F) * 0.4F) * limbYaw;
-        spiderLeg1.rotateAngleY += pair1Y;
-        spiderLeg2.rotateAngleY += -pair1Y;
-        spiderLeg3.rotateAngleY += pair2Y;
-        spiderLeg4.rotateAngleY += -pair2Y;
-        spiderLeg5.rotateAngleY += pair3Y;
-        spiderLeg6.rotateAngleY += -pair3Y;
-        spiderLeg7.rotateAngleY += pair4Y;
-        spiderLeg8.rotateAngleY += -pair4Y;
-        spiderLeg1.rotateAngleZ += pair1Z;
-        spiderLeg2.rotateAngleZ += -pair1Z;
-        spiderLeg3.rotateAngleZ += pair2Z;
-        spiderLeg4.rotateAngleZ += -pair2Z;
-        spiderLeg5.rotateAngleZ += pair3Z;
-        spiderLeg6.rotateAngleZ += -pair3Z;
-        spiderLeg7.rotateAngleZ += pair4Z;
-        spiderLeg8.rotateAngleZ += -pair4Z;
+        float pair2Z = Math.abs(MathHelper.sin(limbSwing * 0.6662F + MathHelper.PI) * 0.4F) * limbYaw;
+        float pair3Z = Math.abs(MathHelper.sin(limbSwing * 0.6662F + MathHelper.PI / 2F) * 0.4F) * limbYaw;
+        float pair4Z = Math.abs(MathHelper.sin(limbSwing * 0.6662F + MathHelper.PI * 1.5F) * 0.4F) * limbYaw;
+        spiderLeg1.yRot += pair1Y;
+        spiderLeg2.yRot += -pair1Y;
+        spiderLeg3.yRot += pair2Y;
+        spiderLeg4.yRot += -pair2Y;
+        spiderLeg5.yRot += pair3Y;
+        spiderLeg6.yRot += -pair3Y;
+        spiderLeg7.yRot += pair4Y;
+        spiderLeg8.yRot += -pair4Y;
+        spiderLeg1.zRot += pair1Z;
+        spiderLeg2.zRot += -pair1Z;
+        spiderLeg3.zRot += pair2Z;
+        spiderLeg4.zRot += -pair2Z;
+        spiderLeg5.zRot += pair3Z;
+        spiderLeg6.zRot += -pair3Z;
+        spiderLeg7.zRot += pair4Z;
+        spiderLeg8.zRot += -pair4Z;
     }
-
-    public Cube spiderHead;
-    public Cube spiderNeck;
-    public Cube spiderBody;
-    public Cube spiderLeg1;
-    public Cube spiderLeg2;
-    public Cube spiderLeg3;
-    public Cube spiderLeg4;
-    public Cube spiderLeg5;
-    public Cube spiderLeg6;
-    public Cube spiderLeg7;
-    public Cube spiderLeg8;
 }
diff --git a/src/main/java/net/minecraft/client/render/model/SquidModel.java b/src/main/java/net/minecraft/client/render/model/SquidModel.java
new file mode 100644
index 000000000..0e65edec1
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/model/SquidModel.java
@@ -0,0 +1,57 @@
+package net.minecraft.client.render.model;
+
+
+// Referenced classes of package net.minecraft.src:
+//            BaseModel, ModelRenderer
+
+public class SquidModel extends BaseModel
+{
+
+    public SquidModel()
+    {
+        squidTentacles = new Cube[8];
+        byte yOffs = -16;
+        squidBody = new Cube(0, 0);
+        squidBody.addBox(-6F, -8F, -6F, 12, 16, 12);
+        squidBody.y += 24 + yOffs;
+        for(int i = 0; i < squidTentacles.length; i++)
+        {
+            squidTentacles[i] = new Cube(48, 0);
+            double angle = ((double)i * Math.PI * 2D) / (double)squidTentacles.length;
+            float xo = (float)Math.cos(angle) * 5F;
+            float yo = (float)Math.sin(angle) * 5F;
+            squidTentacles[i].addBox(-1F, 0.0F, -1F, 2, 18, 2);
+            squidTentacles[i].x = xo;
+            squidTentacles[i].z = yo;
+            squidTentacles[i].y = 31 + yOffs;
+            angle = ((double)i * Math.PI * -2D) / (double)squidTentacles.length + (Math.PI/2);
+            squidTentacles[i].yRot = (float)angle;
+        }
+
+    }
+
+    @Override
+    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    {
+        for(int i = 0; i < squidTentacles.length; i++)
+        {
+            squidTentacles[i].xRot = limbPitch;
+        }
+
+    }
+
+    @Override
+    public void render(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    {
+        setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+        squidBody.render(scale);
+        for(int i = 0; i < squidTentacles.length; i++)
+        {
+            squidTentacles[i].render(scale);
+        }
+
+    }
+
+    Cube squidBody;
+    Cube squidTentacles[];
+}
